local DEFAULTS={
	ver=1,
	speed={[1]=0.4,[2]=0.4,[3]=0.4}, --Fusion,Ele,Multibuy
	FusionStones={
		[1]=true,--Fusionsstein/Ehrenfusionsstein
		[2]=true,--Gewöhnlicher Fusionsstein
		[3]=false,--Makelloser Fusionsstein
	},
	Filters={
		{false,"#rune>0",{all=true,},},
		{false,"tiered",{all=true,},},
		{false,"plus > 0",{all=true,},},
		{false,"#stat = 0 & purple",{all=true,},},
		{false,"purple & #stat = 1",{all=true,},},
		{true,"mana",{all=true,},},
		{true,"white",{all=true,},},
		{true,"blue",{all=true,},},
		{true,"green",{all=true,},},
		{true,"purple",{all=true,},},
	},
	UseBank=false,
}

local me={
	name="ExtFusion",
	tag="EF",
	version= "v1.1-release",
	func={},
	vars={
		loaded=false,
		constantMode=false,
		debug=false,				--debugger
		elapsed		= {0,0,0}, 	--Fusion,Ele,Multibuy
		
		Fusion={		--Fusion
			active		=false,		--gilt nur für Fusion
			Button		=false,		-- true wenn über button einzelne Items fusioniert werden
			Counter		= 0,     	-- count how many stones we did
			QueueStart	= 0,    	-- queue start time <--nicht benutzt bisher
			WaitForFusion=false,	--true wenn items zu fusionieren sind
			filter={},				--Filter die auf dem Character benutzt werden
			queue={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,},--anzahl der zu fusionierenden items (f+1,t2-t20)
		},
		stern={			--sternbildbegleiter
			type=nil,				--feuer,wasser,erde, wind
			level=nil,				--Staub,Sand,Stein,Diamant
			WaitForFusion=0,		--1 wenn elemente zu fusionieren sind, 2 wenn elemente fusioniert worden sind.
			start=false,			--aktiv ja/nein
		},
		bank={
			start=false,
			visible=false,
			mode=0,
			},
		multibuy={		--Storemultibuy
			num=0,					--Anzahl items
			item={0,0},			--1 index im handelsfenster 2 maxheap
		},
	},
}

--[[ [ ]]
local ManaStone = { --Manasteine T1-T20
	[1]=202840,  [2]=202841,  [3]=202842,  [4]=202843,  [5]=202844, 
	[6]=202845,	 [7]=202846,  [8]=202847,  [9]=202848,  [10]=202849, 
	[11]=202850, [12]=202851, [13]=202852, [14]=202853, [15]=202854, 
	[16]=202855, [17]=202856, [18]=202857, [19]=202858, [20]=202859, 
	}

local FusionStones ={
	[1]={--Fusionsstein
		202880,--Kommando I Stärke II
		202882,--Geist II Dunkel I
		202883,--Intellekt I Zauberspruch II
		202885,--Solidarität I, Leben II
		202995,--Flamme I Energie II
		202996,--Lufthauch II, Kommando I
		202997,--Nebel II Geist I
		202998,--Stärke I Leben II
		203000,--Stärke I
		203001,--Ausdauer I
		203002,--Intellekt I
		203003,--Geist I
		203004,--Geschicklichkeit
		206219,--0
		206220,--0
		206227,--0
		206694,--Ehrenfusi 0
		207004,--Bei den schwarzen Jägern... 0
		},
	[2]={202999},--Gewöhnlicher Fusi
	[3]={202881},--Makelloser
}
	
local element={	--Sternbildelemente
	{ 241481, 241342, 241341, 241340, 241339 }, --feuer  1
	{ 241480, 241338, 241337, 241336, 241335 }, --wasser 2
	{ 241479, 241334, 241333, 241332, 241331 }, --luft   3
	{ 241482, 241346, 241345, 241344, 241343 }, --erde   4
}	
--[[ ] ]]
-----------------------------------------------------------------------
-----------------------------------------------------------------------
------------------------------Bagpack/Bank-----------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------
--[[ [ ]]	
local Bagpack={}; --num: 0=Kein Fusionierbares Item, 1,normaler Fusi, 2 Random fusi, 3 makelloser Fusi, table --> Manastein/Item x[i].item=false/true,95 itemshop etc ("seltener" als legendär) 96 --> Gegenstand gesperrt,1xxx-4xxx Sternelemente,97 Rucksackfach nicht gemietet,98 handel, 99leerer slot, 100 unbekannt, 101 = gefiltert
function me.func.GetBagpack(_start,_end) --schreibt Rucksack in table.
	for i=_start or 1,_end or 360 do
		local a,b=GetBagPageLetTime(math.ceil(i/30))
		if type(b)=="number" and b==-1 then
			Bagpack[i]=97;
		else
			Bagpack[i]=nil;
			local bagid, texture, name, itemCount, locked, invalid = GetBagItemInfo(i)
			if itemCount > 0 then
			
				_,id,_ =ParseHyperlink(GetBagItemLink(bagid, true))
				id=tonumber(id,16);
				for z=1,#element do	--Sternbegleiter Elemente
					for y=1,#element[z] do
						if id==element[z][y] then
							Bagpack[i]=z*10000+y*1000+itemCount
						end
					end
				end
			end
			if Bagpack[i]==nil then
				if locked then
					Bagpack[i]=98;
				elseif itemCount==0 then
					Bagpack[i]=99 --leerer Slot (100--> unbekannt)
				elseif itemCount>1 and  Bagpack[i]== nil then 
					Bagpack[i]=0 --Kein Fusionierbares Item
				else
					for x=1,#FusionStones do
						for z=1,#FusionStones[x] do
							if id==FusionStones[x][z] then
								Bagpack[i]=x;
							end
						end
					end
					for z=1,#ManaStone do
						if id==ManaStone[z] then
							_,link,_ =ParseHyperlink(GetBagItemLink(bagid, false)) --Item überprüfen
							local stats={}
							local _,_,_,stat12,stat34,stat56=string.match(link,"(%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+)")
							stats[1],stats[2]=string.match(stat12,"(%x%x%x%x)(%x*)")
							stats[3],stats[4]=string.match(stat34,"(%x%x%x%x)(%x*)")
							stats[5],stats[6]=string.match(stat56,"(%x%x%x%x)(%x*)")
							for i=1,6 do
								if stats[i]==nil then stats[i]="" end
								if stats[i]~="" then
									stats[i]=tonumber(tostring(5)..tostring(tonumber(stats[i],16)))
								else
									stats[i]=nil;
								end
							end
							Bagpack[i]={item=false,id=id,stats=stats}--Manastein
						end
					end
					if Bagpack[i]==nil and name then
						_,link,_ =ParseHyperlink(GetBagItemLink(bagid, false)) --Item überprüfen
						Bagpack[i]=me.func.ReadItemLink(link)--Itemlink parsen: rückgaben: item(immer true),ID,dura{dura maxdura},tiered,quality,plus,runeslots,stats,runes,bound	
					end
					if Bagpack[i]==nil  then
					
						DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Bagslot "..i.." unbekannt!") 
					end
				end
			end
		end
	end
end

local Bank={}
function me.func.GetBank(_start,_end) --schreibt Bank in Rucksack (wenn tragbar)
	for i=_start or 1,_end or 200 do
		local b=0
		if i>40 then
			b=TimeLet_GetLetTime( "BankBag" .. math.ceil(i/40) )
		else
			b=1
		end
		if b<=0 then
			Bank[i]=97;
		else
			Bank[i]=nil;
			local texture, name, itemCount, locked = GetBankItemInfo(i)
			if itemCount==nil then
				Bank[i]=99 --leerer Slot (100--> unbekannt)
			else
				if itemCount > 0 then
					_,link,_ =ParseHyperlink(GetBankItemLink(i))
					id=tonumber(string.sub(link,1,5),16);
					for z=1,#element do	--Sternbegleiter Elemente
						for y=1,#element[z] do
							if id==element[z][y] then
								Bank[i]=z*10000+y*1000+itemCount
							end
						end
					end
				end
				if Bank[i]==nil then
					if locked then
						Bank[i]=98;
					elseif itemCount==0 then
						Bank[i]=99 --leerer Slot (100--> unbekannt)
					elseif itemCount>1 then 
						Bank[i]=0 --Kein Fusionierbares Item
					else
						for x=1,#FusionStones do
							for z=1,#FusionStones[x] do
								if id==FusionStones[x][z] then
									Bank[i]=x;
								end
							end
						end
						for z=1,#ManaStone do
							if id==ManaStone[z] then
								_,link,_ =ParseHyperlink(GetBankItemLink(i, false)) --Item überprüfen
								local stats={}
								local _,_,_,stat12,stat34,stat56=string.match(link,"(%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+)")
								stats[1],stats[2]=string.match(stat12,"(%x%x%x%x)(%x*)")
								stats[3],stats[4]=string.match(stat34,"(%x%x%x%x)(%x*)")
								stats[5],stats[6]=string.match(stat56,"(%x%x%x%x)(%x*)")
								for i=1,6 do
									if stats[i]==nil then stats[i]="" end
									if stats[i]~="" then
										stats[i]=tonumber("7"..stats[i],16)
									else
										stats[i]=nil;
									end
								end
								Bank[i]={item=false,id=id,stats=stats}--Manastein
							end
						end
						if Bank[i]==nil and name then
							_,link,_ =ParseHyperlink(GetBankItemLink(i)) --Item überprüfen
							Bank[i]=me.func.ReadItemLink(link)--Itemlink parsen: rückgaben: item(immer true),ID,dura{dura maxdura},tiered,quality,plus,runeslots,stats,runes,bound	
						end
						if Bank[i]==nil  then
							DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Bagslot "..i.." unbekannt!") 
						end
					end
				end
			end
		end
	end
end

function me.func.ReadItemLink(link)
	if type(link)=="string" and string.match(link,"(%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+)") then
		local id,bound=0,0 		--id (dezimal), gebunden/ungebunden/PVPSchutz etc
		local plus,tier=0,0  	--plus, graderhöhung (t5 item auf t12 --> 7)
		local dura,maxdura=0,0 	--current dura, maximaldura
		local freeruneslots=0  	--Anzahl freier Runenslots
		local stats={}  		--stats (dezimal id)
		local runes={}			--runen (dezimal id)
		local rarity,quality=0,0 --seltenheit(Crafting!), Farbe
		
		local _id,_bound,multistuff,stat12,stat34,stat56,rune1,rune2,rune3,rune4,_dura,hash=string.match(link,"(%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+) (%x+)")
		id=tonumber(_id,16)
		if id>=210000 and id<240000 then
			quality=GetQualityByGUID(id)
			bound=_bound
			stats[1],stats[2]=string.match(stat12,"(%x%x%x%x)(%x*)")
			stats[3],stats[4]=string.match(stat34,"(%x%x%x%x)(%x*)")
			stats[5],stats[6]=string.match(stat56,"(%x%x%x%x)(%x*)")
			for i=1,6 do
				if stats[i]==nil then stats[i]="" end
				if stats[i]~="" then
					stats[i]=tonumber("7"..stats[i],16)
				else
					stats[i]=nil;
				end
			end
			runes={tonumber(rune1,16),tonumber(rune2,16),tonumber(rune3,16),tonumber(rune4,16)}
			for i=1,4 do 
				if runes[i]==0 then runes[i]=nil end --112 --> 70h
			end
			dura=tonumber(_dura,16)/100;

			for i=1,8 do
				if string.len(multistuff)<8 then 
					multistuff="0"..multistuff 
				else
					_,plus,tier,maxdura=string.match(multistuff,"(%x%x)(%x%x)(%x%x)(%x%x)")
					plus=tonumber(plus,16)
					tier=tonumber(tier,16)
					maxdura=tonumber(maxdura,16)
					break;
				end
			end
			
			rarity=math.floor(tier/32)
			tier=tier-(rarity*32)-10
			
			freeruneslots=math.floor(plus/32)
			plus=plus-freeruneslots*32
			if quality > 5 then
				return 95
			elseif string.match(bound,"%x*(%x)$") and tonumber(string.match(bound,"%x*(%x)$"),16) >=8 then --Gesperrte/nicht fusionierbare items
				return 96
			else
				local data={
					item=true,
					id=id,					--itemid
					dura={dura,maxdura},	--Dura/Maxdura
					tiered=tier,			--Gegradet um x
					quality=quality,		--Seltenheit
					rarity=rarity,			--crafterseltenheit
					plus=plus,				--Geplusst
					runeslots=freeruneslots,--Freie Runenslots
					stats=stats,			--stats 1-6
					runes=runes,			--runen 1-6
					bound=bound,			--Gebunden/entbunden etc	
				};
				return data;
			end
		else
			return 0 -- kein fusionierbares Item
		end
	else
		return 99 --leerer Slot, sollte nie zurückgegeben werden
	end	
end

function me.func.PrintBank(i) --gibt table aus.
	if type(Bank[i])=="table" then
		for a,b in pairs(Bank[i]) do
			DEFAULT_CHAT_FRAME:AddMessage(tostring(a).." "..tostring(b))
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage(tostring(Bank[i]))
	end
end

function me.func.PrintBagpack(i) --gibt table aus.
	if type(Bagpack[i])=="table" then
		for a,b in pairs(Bagpack[i]) do
			DEFAULT_CHAT_FRAME:AddMessage(tostring(a).." "..tostring(b))
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage(tostring(Bagpack[i]))
	end
end

local ItemTooltip={};
function me.func.GetItemTooltip(id)
	local level=0;
	id=id or 0
	GameTooltip:SetHyperLink("|Hitem:" .. string.format("%x", id) .. "|h|h")
	for i=1,10 do
	local txt=_G["GameTooltipTextLeft"..i]:GetText()	
		if string.find(txt,TEXT("TOOLTIP_LIMIT_TEXT")) and string.find(txt,TEXT("TOOLTIPS_LIMIT_LEVEL")) and string.match(txt,"%d+") then
			level=tonumber(string.match(txt,"%d+"));
			break
		end			
	end
	GameTooltip:Hide()
	GameTooltip1:Hide()
	GameTooltip2:Hide()
	ItemTooltip[id]={level=level}
end

local translate={};
function me.func.GetInventoryTranslation()
	for i=1,360 do
		local num=GetBagItemInfo(i)
		translate[num]=i;
	end
end
--[[ ] ]]	
-----------------------------------------------------------------------
-----------------------------------------------------------------------
----------------------------Basisfunktionen----------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------
--[[ [ ]]
function me.func.RegisterEvents(this)
	this:RegisterEvent("BAG_ITEM_UPDATE")
	this:RegisterEvent("VARIABLES_LOADED")
	
	this:RegisterEvent("STORE_OPEN")
	this:RegisterEvent("STORE_CLOSE")
end

function me.func.OnEvent(event)
	if event=="VARIABLES_LOADED" and not me.vars.loaded then 
		if (type(ExtFusion_Settings) ~= "table") then
			ExtFusion_Settings = DEFAULTS
		else
			for a, b in pairs(DEFAULTS) do
				if type(ExtFusion_Settings[a]) == "nil" then
					ExtFusion_Settings[a] = b;
				elseif type(ExtFusion_Settings[a])=="table" and tostring(a)~="Filters" then
					for c,d in pairs(DEFAULTS[a]) do
						if type(ExtFusion_Settings[a][c]) == "nil" then
							ExtFusion_Settings[a][c] = d;
						elseif type(ExtFusion_Settings[a][c])=="table" then
							for e,f in pairs(DEFAULTS[a][c]) do
								if type(ExtFusion_Settings[a][c][e]) == "nil" then 		
									ExtFusion_Settings[a][c][e] = f;
								elseif type(ExtFusion_Settings[a][c][e])=="table" then
									for g,f in pairs(DEFAULTS[a][c][e]) do
										if type(ExtFusion_Settings[a][c][e][g]) == "nil" then 		
											ExtFusion_Settings[a][c][e][g] = h;
										end;
									end;	
								end;
							end;
						end;
					end;
				end;
			end;
		end;
		SaveVariables("ExtFusion_Settings")
		me.func.LoadLoka()
		me.func.SetFrameText()
		
		me.func.initialize()
		me.func.GetInventoryTranslation()
		me.vars.loaded=true
	elseif event=="STORE_OPEN" or event=="STORE_CLOSE" and me.vars.loaded then
		me.vars.multibuy={num=0,item={0,0}};
	elseif event=="BAG_ITEM_UPDATE" then 
		if ExtFusion_FS:IsVisible() and me.vars.Fusion.active==true and me.vars.loaded then	
			if translate[arg1] then
				local num=translate[arg1]
				me.func.GetBagpack(num,num)
			end
		end	
		if me.vars.constantMode and not me.vars.Fusion.active then
			me.func.QueueStartStop(true);
		end
		
	end
end

function me.func.OnLoad(this)
	ITEM_QUEUE_FRAME_UPDATETIME = 0
	ITEM_QUEUE_FRAME_INSERTITEM = 0
	me.func.RegisterEvents(this)
end


function me.func.OnUpdate(_elapsedTime)
	for i=1,3 do
		me.vars.elapsed[i] = me.vars.elapsed[i] + _elapsedTime;
	end
	if me.vars.bank.start and ExtFusion_Settings.UseBank then	
		if me.vars.bank.mode==1 then
			for z=1,180 do
				if type(Bagpack[z])=="table" then
					if me.func.CheckCondition(z,Bagpack,me.vars.Fusion.filter) and Bagpack[z].item then
						for i=1,200 do
							if Bank[i]==99 then
								if not ExtFusion.vars.bank.visible then
									CloseWindows();
									OpenBank()
								end
								PickupBagItem(GetBagItemInfo(z))
								PickupBankItem(i)
								Bank[i]=Bagpack[z]
								Bagpack[z]=100
								return
							end
						end
					end
				elseif type(Bagpack[z])=="number" and ExtFusion_Settings.FusionStones[Bagpack[z]] then
					for i=1,200 do
						if Bank[i]==99 then
							if not ExtFusion.vars.bank.visible then
								CloseWindows();
								OpenBank()
							end
							PickupBagItem(GetBagItemInfo(z))
							PickupBankItem(i)
							Bank[i]=Bagpack[z]
							Bagpack[z]=100
							return
						end
					end
				end	
			end
			me.vars.bank.mode=2
			return
		elseif me.vars.bank.mode>=2 and me.vars.bank.mode<3 then
			me.vars.bank.mode=me.vars.bank.mode+0.1
			return
		end
		if not ExtFusion.vars.bank.visible and ExtFusion_Settings.UseBank then
			CloseBank()
			BankFrame:Hide()
		end
		me.vars.bank.mode=0
		me.vars.bank.start=false
	end
	if StoreFrame:IsVisible() and me.vars.elapsed[3] > ExtFusion_Settings.speed[3] then
		if me.vars.multibuy.item[1] > 0 and me.vars.multibuy.num > 0 then	
			if me.vars.multibuy.item[2]>me.vars.multibuy.num then
				StoreBuyItem(me.vars.multibuy.item[1],me.vars.multibuy.num)
				me.vars.multibuy.num=me.vars.multibuy.num-me.vars.multibuy.num
			else
				StoreBuyItem(me.vars.multibuy.item[1],me.vars.multibuy.item[2])
				me.vars.multibuy.num=me.vars.multibuy.num-me.vars.multibuy.item[2]
			end
			if me.vars.multibuy.num==0 then
				me.vars.multibuy.item[1]=0;
				me.vars.multibuy.item[2]=0;
			end
			me.vars.elapsed[3]=0;
		end
	end
	
	if me.vars.stern.start and me.vars.elapsed[2] > ExtFusion_Settings.speed[2] then
		if GetMagicBoxEnergy() > 0 then
			me.func.GetBagpack()
			ExtFusion.func.StartStop(me.func.Stern())
			me.vars.elapsed[2]=0;
			return
		else
			ExtFusion.func.StartStop()
			SendSystemMsg("Keine Aufladungen vorhanden!")			
		end
	end
	
	if me.vars.Fusion.active and me.vars.elapsed[1] > ExtFusion_Settings.speed[1] then
		if GetMagicBoxEnergy() == 0 then
			SendSystemMsg("Keine Aufladungen vorhanden!")
			me.func.QueueStartStop(false)--me.vars.Fusion.active=false;
		else
			--/run local func=ExtFusion.func.CreateStones ExtFusion.func.CreateStones=function() ExtFusion.func.GetBagpack()func() end
			me.func.GetBagpack()
			me.func.CreateStones()
			me.vars.elapsed[1]=0;
			return
		end
	end
	
end

function me.func.SetCharacterFilter(num)
	if type(ExtFusion_Settings.Filters[num][3])~="table" then ExtFusion_Settings.Filters[num][3]={all=true,} end
	ExtFusion_Settings.Filters[num][3][UnitName("player")]=true
	ExtFusion_Settings.Filters[num][3]["all"]=false	
end

function me.func.GetUsedFilter(name)
	if me.vars.debug then
		DEFAULT_CHAT_FRAME:AddMessage("GetUsedFilter("..tostring(name)..")")
	end
	local filter={}
	if type(name)~="string" then name=UnitName("player") end
	for num=1,#ExtFusion_Settings.Filters do
		if type(ExtFusion_Settings.Filters[num][3])~="table" then --prüft ob name eingetragen wurde
			ExtFusion_Settings.Filters[i][3]={all=true,} 
		end 
		
		if type(ExtFusion_Settings.Filters[num][3][name])=="boolean" then
			if ExtFusion_Settings.Filters[num][3][name]==true then
				--benutze filter
				table.insert(filter,ExtFusion_Settings.Filters[num])
			elseif ExtFusion_Settings.Filters[num][3][name]==false then
				--benutze filter nicht
			end
		elseif type(ExtFusion_Settings.Filters[num][3][name])=="nil" then
			if ExtFusion_Settings.Filters[num][3]["all"]==true then
				--benutze filter
				table.insert(filter,ExtFusion_Settings.Filters[num])
			else
				--benutze filter nicht
			end
		end
	end
	return filter
end
--[[ ] ]]
-----------------------------------------------------------------------
-----------------------------------------------------------------------
--------------------------------Fusion---------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------
--[[ [ ]]
function me.func.CreateStones()
	if me.vars.Fusion.WaitForFusion then
		me.vars.Fusion.WaitForFusion=false
		if me.vars.debug then
			for i=51,55 do
				local icon,name=GetGoodsItemInfo(i)
				if name~="" or icon~="" then
					DEFAULT_CHAT_FRAME:AddMessage( GetBagItemLink(i).. " fusioniert!")
				end
			end
		else		
			MagicBoxRequest();
		end
		return 4
	end
	
	local returnvar=false
	for i=51,55 do
		local icon,name=GetGoodsItemInfo(i)
		if name~="" or icon~="" then
			for z=1,360 do
				if (tostring(Bagpack[z])=="99") then
					PickupBagItem(i);
					PickupBagItem(GetBagItemInfo(z));
					Bagpack[z]=100;
					break;
				end
			end
			returnvar=true;
		end
	end
	if returnvar then return 1 end;
	for i=1,20 do
		if me.vars.Fusion.queue[i]>0 then
			if i==1 then
				if(me.func.FusionItem()) then
					me.vars.Fusion.WaitForFusion=true
					me.vars.Fusion.Counter=me.vars.Fusion.Counter+1
					me.vars.Fusion.queue[i]=me.vars.Fusion.queue[i]-1
					if not me.vars.Fusion.Button then
						_G["ExtFusion_FS_EditBox".. i]:SetText(me.vars.Fusion.queue[i])
					end
					return 2
				end
			else
				if (me.func.FusionMana(i)) then
					me.vars.Fusion.WaitForFusion=true
						me.vars.Fusion.Counter=me.vars.Fusion.Counter+1
						me.vars.Fusion.queue[i]=me.vars.Fusion.queue[i]-1
					if not me.vars.Fusion.Button then
						_G["ExtFusion_FS_EditBox".. i]:SetText(me.vars.Fusion.queue[i])
					end
					return 3
				end;
			end
		end
		if i==20 and returnvar==false then --wenn nichts mehr in schleife dann beende 
			me.func.QueueStartStop(false)--me.vars.Fusion.active=false;
			me.vars.Fusion.Button=false 
			return 99 
		end; 
	end
end

function me.func.FusionMana(tier)
	local mana={};
	for i=1,360 do
		if type(Bagpack[i])=="table" and not Bagpack[i].item and #mana <3 and Bagpack[i].id==ManaStone[tier-1] then
			if me.func.CheckCondition(i,Bagpack,me.vars.Fusion.filter) then
				local id=GetBagItemInfo(i)
				table.insert(mana,id)
				if #mana==3 then
					break
				end
			else
				Bagpack[i]=101
			end
		end
	end
	if #mana==3 then		
		PickupBagItem(mana[1])
		PickupBagItem(51)
		PickupBagItem(mana[2])
		PickupBagItem(52)
		PickupBagItem(mana[3])
		PickupBagItem(53)
		return true 
	end;
	return false
end

function me.func.FusionItem()
local item,item2=nil
local fusi,fusi2=nil
	for i=1,360 do
		if type(Bagpack[i])=="table" and Bagpack[i].item and not item then
			if me.func.CheckCondition(i,Bagpack,me.vars.Fusion.filter) then
				item=i;
			else
				Bagpack[i]=101;
			end
		end
		if not fusi and type(Bagpack[i])=="number" and  ExtFusion_Settings.FusionStones[Bagpack[i]] then
			fusi=i;
		end
	end
	if ExtFusion_Settings.UseBank and TimeLet_GetLetTime("BankLet")>0 and (not item or not fusi) then
		ExtFusion.vars.bank.visible=BankFrame:IsVisible()
		for i=1,200 do	
			local occupiedSlots, availableSlots, totalSlots = GetBagCount()
			if availableSlots-occupiedSlots>5 or (item and not fusi and availableSlots-occupiedSlots>4)or (not item and fusi  and availableSlots-occupiedSlots>3) then
				if type(Bank[i])=="table" and Bank[i].item and not item  then
					if me.func.CheckCondition(i,Bank,me.vars.Fusion.filter) then
						if not bank_is_visible then
							CloseWindows();
							OpenBank()
						end
						DrawBankItem(i);
						item2=true
					else
						Bank[i]=101;
					end
				end
				if type(Bank[i])=="number" and  ExtFusion_Settings.FusionStones[Bank[i]] and not fusi then
					if not bank_is_visible then
						CloseWindows();
						OpenBank()
					end
					DrawBankItem(i);
					item2=true
				end
			else
				break
			end
		end	
		if item2 or fusi2 then
			ExtFusion.vars.bank.mode=2
			ExtFusion.vars.bank.start=true
			me.vars.Fusion.queue[1]=me.vars.Fusion.queue[1]+1
			return true
		end	
	end
	if type(fusi)=="number"  and type(item)=="number" then
		PickupBagItem(GetBagItemInfo(fusi))
		PickupBagItem(51)
		PickupBagItem(GetBagItemInfo(item))
		PickupBagItem(52) 
		return true
	end
	return false
end
--[[ ] ]]
-----------------------------------------------------------------------
-----------------------------------------------------------------------
--------------------------------Filter---------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------
--[[ [ ]]
function me.func.PrintFilter()
	for i=1,#ExtFusion_Settings.Filters do
		DEFAULT_CHAT_FRAME:AddMessage(tostring(ExtFusion_Settings.Filters[i][1]).." "..tostring(ExtFusion_Settings.Filters[i][2]))
	end	
end

function me.func.PrintFilter2(start,ende,empty,name)
	start=(start or ExtFusion_Config_advanced_Slider1:GetValue())
	ende=(ende or ExtFusion_Config_advanced_Slider2:GetValue())
	local tbl={}
	if type(ende)~="number" then
		ende=360
	else
		if ende>360 then ende=360 end
	end
	if type(start)~="number" then
		start=1
	else
		if start<1 then start=1 end
	end
	if ende<start then
		DEFAULT_CHAT_FRAME:AddMessage("Eingabefehler!")
	else
		local filters=me.func.GetUsedFilter(name)
		for i=start,ende do
			if type(Bagpack[i])=="table" then
				local bool,filter=me.func.CheckCondition(i,Bagpack,filters)
				if bool then
					table.insert(tbl,{i,{TEXT("Sys"..Bagpack[i].id.."_name"),Bagpack[i]},(GetBagItemLink(GetBagItemInfo(i), false)or""),true,true,tostring(filter)})
				else
					table.insert(tbl,{i,{TEXT("Sys"..Bagpack[i].id.."_name"),Bagpack[i]},(GetBagItemLink(GetBagItemInfo(i), false)or""),false,true,tostring(filter)})	
				end
			elseif empty==true then
				if type(Bagpack[i])~=nil then
					table.insert(tbl,{i,Bagpack[i],(GetBagItemLink(GetBagItemInfo(i), false)or""),false,false})
				else
					table.insert(tbl,{i,-1,(GetBagItemLink(GetBagItemInfo(i), false)or""),false,false})
				end
			end
		end
	end
	me.func.Config_Advanced_ListRepaint(tbl)
end

function me.func.PrintFilter3(start,ende,empty,name)
	start=(start or ExtFusion_Config_advanced_Slider1:GetValue())
	ende=(ende or ExtFusion_Config_advanced_Slider2:GetValue())
	local tbl={}
	if type(ende)~="number" then
		ende=200
	else
		if ende>200 then ende=200 end
	end
	if type(start)~="number" then
		start=1
	else
		if start<1 then start=1 end
	end
	if ende<start then
		DEFAULT_CHAT_FRAME:AddMessage("Eingabefehler!")
	else
		local filters=me.func.GetUsedFilter(name)
		for i=start,ende do
			if type(Bank[i])=="table" then
				local bool,filter=me.func.CheckCondition(i,Bank,filters)
				if bool then
					table.insert(tbl,{i,{TEXT("Sys"..Bank[i].id.."_name"),Bank[i]},(GetBankItemLink(i, false)or""),true,true,tostring(filter)})
				else
					table.insert(tbl,{i,{TEXT("Sys"..Bank[i].id.."_name"),Bank[i]},(GetBankItemLink(i, false)or""),false,true,tostring(filter)})
				end
			elseif empty==true then
				if type(Bank[i])~=nil then
					table.insert(tbl,{i,Bank[i],(GetBankItemLink(i, false)or""),false,false})
				else
					table.insert(tbl,{i,-1,(GetBankItemLink(i, false)or""),false,false})
				end
			end
		end
	end
	me.func.Config_Advanced_ListRepaint(tbl)
end

local Filterpatterns1={ --items
	{"$","stat","rune",},											--namefilter
	{"mana","tiered","white","green","blue","purple","orange"},		--keywordfilter
	{"#stat","#rune","plus","ftier","level","bagslot","bagpack","dura","iid"},	--vergleichfilter
	}
local Filterpatterns2={--manasteine
	{"$","stat",},
	{"mana"},
	{"#stat","bagslot","bagpack"},
	}
local booleannot="|" --gegenteil
local logicand="&" --Verknüpfung

function me.func.CheckCondition(itemnum,tbl,filters)
	local bool=false
	local check,ffilter,ffilter2
	for i=1,#filters do
		local filter,num={},1
		local txt=string.lower(filters[i][2])
		while string.gsub(txt," ","")~=txt do
			txt=string.gsub(txt," ","")
		end
		while string.find(txt,logicand) do
			filter[num]=string.sub(txt,0,string.find(txt,logicand)-1)
			txt=string.sub(txt,string.find(txt,logicand)+1,string.len(txt))
			num=num+1
			if num > 20 then break end
		end
		filter[num]=txt;
		if tbl[itemnum].item then
			check=me.func.checkfilter_item(filter,itemnum,tbl)--items
		else
			check=me.func.checkfilter_mana(filter,itemnum,tbl)--manasteine
		end
		if filters[i][1]==false and check then
			return false,filters[i][2]
		end --Bedingung nicht erfüllt
		if filters[i][1]==true  and check then
			bool = true 
			ffilter=filters[i][2]
		end
	end
	if bool then 
		return true,ffilter
	else 
		return false,0 --[[0 keine Bedingung]] 
	end
end

function me.func.checkfilter_item(filter,itemnum,tbl)--items
	for i=1,#filter do
		local bool=true
		filter[i]=string.gsub(filter[i],"*",".+")
		if string.match(filter[i],"^"..booleannot..".+") then
			bool=false
			filter[i]=string.sub(filter[i],2,string.len(filter[i]))
		end
		local returnedboolean=true
		for y=1,#Filterpatterns1 do
			for z=1,#Filterpatterns1[y] do
				if string.match(filter[i],"^"..Filterpatterns1[y][z]..".*") then
					if y==1 then
						returnedboolean=me.func.filter_checkname(itemnum,filter[i],Filterpatterns1[y][z],tbl)
					elseif y==2 then
						returnedboolean=me.func.filter_checkkeyword(itemnum,z,tbl)
					elseif y==3 then
						returnedboolean=me.func.filter_checknum(itemnum,filter[i],Filterpatterns1[y][z],tbl)	
					end
				end
			end
		end
		if ((not returnedboolean and bool) or (returnedboolean and not bool)) then
			return false
		end
	end
	return true
end

function me.func.checkfilter_mana(filter,itemnum,tbl)--items
	for i=1,#filter do
		local bool=true
		filter[i]=string.gsub(filter[i],"*",".+")
		if string.match(filter[i],"^"..booleannot..".+") then
			bool=false
			filter[i]=string.sub(filter[i],2,string.len(filter[i]))
		end
		local returnedboolean=true
		local check=true
		for y=1,#Filterpatterns2 do
			for z=1,#Filterpatterns2[y] do
				if string.match(filter[i],"^"..Filterpatterns2[y][z]..".*") then
					check=false
					if y==1 then
						returnedboolean=me.func.filter_checkname(itemnum,filter[i],Filterpatterns2[y][z],tbl)
					elseif y==2 then
						returnedboolean=me.func.filter_checkkeyword(itemnum,z,tbl)
					elseif y==3 then
						returnedboolean=me.func.filter_checknum(itemnum,filter[i],Filterpatterns2[y][z],tbl)	
					end
				end
			end
		end
		if ((not returnedboolean and bool) or (returnedboolean and not bool)) or check then
			return false
		end
	end
	return true
end

function me.func.filter_checkname(itemnum,filter,pattern,tbl)
	filter=string.match(filter,pattern.."(.+)")
	if pattern=="$" then
		if string.match(string.gsub(string.lower(TEXT("Sys"..tbl[itemnum].id.."_name"))," ",""),"^"..filter.."$") then --Wenn itemname mit name im filter übereinstimmt gebe wahr zurück ansonsten false
			return true
		else
			return false
		end
	elseif pattern=="stat" then
		for i=1,#tbl[itemnum].stats do
			if string.match(string.gsub(string.lower(TEXT("Sys"..tbl[itemnum].stats[i].."_name"))," ",""),"^"..filter.."$") then --Wenn statname mit name im filter übereinstimmt gebe wahr zurück ansonsten false
				return true
			end
		end
		return false
	elseif pattern=="rune" then
		for i=1,#tbl[itemnum].runes do
			if string.match(string.gsub(string.lower(TEXT("Sys"..tbl[itemnum].runes[i].."_name"))," ",""),"^"..filter.."$") then --Wenn runenname mit name im filter übereinstimmt gebe wahr zurück ansonsten false
				return true
			end
		end
		return false	
	end
end

function me.func.filter_checknum(itemnum,filter,pattern,tbl)
	filter=string.match(filter,pattern.."(.+)")
	local comparenum=0;
	local compare,num =string.match(filter,"([><=]+)(%d+)$")
	num=tonumber(num)
	if pattern=="#stat" then
		comparenum=#tbl[itemnum].stats
	elseif pattern=="#rune" then
		comparenum=#tbl[itemnum].runes
	elseif pattern=="plus" then
		comparenum=tbl[itemnum].plus
	elseif pattern=="ftier" then
		comparenum=me.func.GetItemFusionTier(tbl[itemnum].id)
	elseif pattern=="level" then
		if ItemTooltip[id] then
			comparenum=ItemTooltip[id].level
		else
			me.func.GetItemTooltip(id)
			comparenum=ItemTooltip[id].level
		end
	elseif pattern=="iid" then
		comparenum=tbl[itemnum].id
	elseif pattern=="bagslot" then
		comparenum=itemnum
	elseif pattern=="bagpack" then
		comparenum=math.ceil(itemnum/30)
	elseif pattern=="dura" then
		comparenum=tbl[itemnum].dura[2]
	end
	if string.find(compare,">") and string.find(compare,"<") then
		if comparenum~=num then return true end
	else
		if string.find(compare,">") then
			if comparenum>num then return true end
		elseif string.find(compare,"<") then
			if comparenum<num then return true end
		end
		if string.find(compare,"=") then
			if comparenum==num then return true end
		end
	end

	return false;
end

function me.func.filter_checkkeyword(itemnum,patternnum,tbl)
	if patternnum==1 then
		if tbl[itemnum].item==false then
			return true
		else
			return false
		end
	elseif patternnum==2 then
		if tbl[itemnum].tiered > 0 then
			return true
		else
			return false
		end
	else
		if tbl[itemnum].quality==patternnum-3 then--weiß==0 grün 1 blau 2 lila 3 episch 4 legendär 5,
			return true
		else 
			return false
		end
	end
end

function me.func.GetItemFusionTier(id)
	local lvl=0
	if ItemTooltip[id] then
		lvl=ItemTooltip[id].level
	else
		me.func.GetItemTooltip(id)
		lvl=ItemTooltip[id].level
	end
	quality=GetQualityByGUID(id)
	for i=1,10 do
		if quality == 0 then --weiß
			if i*20>=lvl then
				return i
			end
		elseif quality == 1 then --grün
			if (i*20-3)>=lvl then
				return i
			end
		elseif quality == 2 then --blau
			if (i*20-7)>=lvl then
				return i
			end		
		elseif quality == 3 then --lila
			if (i*20-13)>=lvl then
				return i
			end		
		elseif quality == 4 then --episch
			if (i*20-17)>=lvl then
				return i
			end		
		elseif quality == 5 then --legendär
			if (i*20-23)>=lvl then
				return i
			end		
		else
			return 0
		end
	end
end

--[[ ] ]]
-----------------------------------------------------------------------
-----------------------------------------------------------------------
------------------------------Sternbild--------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------

--[[ [ ]]
--feuer 1 wasser 2 luft 3 erde 4
function me.func.Stern()
	if me.vars.stern.WaitForFusion then
		me.vars.stern.WaitForFusion=false
		if me.vars.debug then
			for i=51,55 do
				local icon,name=GetGoodsItemInfo(i)
				if name~="" or icon~="" then
					DEFAULT_CHAT_FRAME:AddMessage( GetBagItemLink(i).. " fusioniert!")
				end
			end
		else		
			MagicBoxRequest();
			return true
		end
	end
	--Arkaner Umwandler leeren
	local returnvar=false
	for i=51,55 do
		local icon,name=GetGoodsItemInfo(i)
		if name~="" or icon~="" then
			for z=1,360 do
				if (tostring(Bagpack[z])=="99") then
					PickupBagItem(i);
					PickupBagItem(GetBagItemInfo(z));
					Bagpack[z]=100;
					break;
				end
			end
			returnvar=true;
		end
	end
	if returnvar then return true end;
	
	--Elemente im Rucksack suchen
	local elements={}
	for i=1,360 do
		if type(Bagpack[i])=="number" and Bagpack[i]>1000 then
			local etype,elvl,num=string.match(tostring(Bagpack[i]),"(%d)(%d)(%d%d%d)")
			if type(elements[(etype..elvl)])~="table" then
				elements[(etype..elvl)]={}
			end
			table.insert(elements[(etype..elvl)],{i,tonumber(num)})
		end
	end
	if me.vars.debug then
		for i=1,#elements do
			DEFAULT_CHAT_FRAME:AddMessage(elements[1].." "..elements[2])
		end
	end
	if me.vars.stern.type and me.vars.stern.level then
		for i=1, (tonumber(me.vars.stern.level)) do
		--Fasse Stapel zusammen
			local ele=elements[me.vars.stern.type .. me.vars.stern.level-i+1] --table mit Slots und Anzahl der Elemente einer Stufe
			if ele and #ele>1 then
				if ele[1][1]+ele[2][1]<=999 then
					if me.vars.debug then
						DEFAULT_CHAT_FRAME:AddMessage("Mehr als 3 "..TEXT("Sys"..element[me.vars.stern.type][me.vars.stern.level-i+1].."_name").."gefunden. -> |cff00ff00Stacks verbinden, return true")
					end
					PickupBagItem( GetBagItemInfo(ele[2][1]) );
					PickupBagItem( GetBagItemInfo(ele[1][1]) );
					return true;
				end
			end
		end
		if ( GetBagItemCount(element[me.vars.stern.type][me.vars.stern.level]) >= 3 ) then 
			return false
		else
			local slot,num=0,0
			for i=1, (tonumber(me.vars.stern.level) -1) do
			--Suche den kleinsmöglich stapel und lege ihn in den arkanen umwandler
				local ele=elements[me.vars.stern.type .. me.vars.stern.level-i] --table mit Slots und Anzahl der Elemente einer Stufe
				if GetBagItemCount(element[me.vars.stern.type][me.vars.stern.level-i])>=3 then 
					for z=1,#ele do
						if ele[z][2]>=3 then
							if ele[z][2]==3 then
								slot=z
								num=3
								break
							elseif ele[z][2]>3 and (ele[z][2]< num or num <3) then
								slot=z
								num=ele[z][2]
							end
						end
					end
					if slot~=0 and num~=0 then
						if num==3 then
							PickupBagItem(GetBagItemInfo(ele[slot][1]));
						else
							SplitBagItem(GetBagItemInfo(ele[slot][1]),3)
						end
						PickupBagItem( 51 );
						me.vars.stern.WaitForFusion=true;
						if me.vars.debug then
							DEFAULT_CHAT_FRAME:AddMessage("3 "..TEXT("Sys"..element[me.vars.stern.type][me.vars.stern.level-i].."_name").."in den arkanen Umwandler. -> |cff00ff00return true")
						end
						return true
					end
				end
			end
		end
	end
	return false
end
--[[ ] ]]
-----------------------------------------------------------------------
-----------------------------------------------------------------------
------------------------------MultiBuy---------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------
--[[ [ ]]
local moneyTypes={
	[1]	={1,"copper"},		--GetPlayerMoney,Gold
	[2]	={1,"account"},  	-- s.o. ,Diamanten
	[3]	={1,"bonus"}, 		--s.o. ,Rubine
	[4]	={1,"billdin"},		--s.o. , Phiriusmarken
	[5]	={2,{3,1}},			--GetPlayerPointInfo, Ehrenpunkte
	[6]	={0},	--unknown
	[7]	={0},	--unknown
	[8]	={0},	--unknown
	[9]	={2,{3,2}},			--GetPlayerPointInfo, BK Abzeichen
	[10]={2,{2,1}},			--GetPlayerPointInfo, Alte Mementos
	[11]={2,{1,3}},			--GetPlayerPointInfo, Traumlandpionier
	[12]={2,{1,1}},			--GetPlayerPointInfo Phiriusmuschel
	[13]={2,{1,2}},			--GetPlayerPointInfo Energie der Gerechtigkeit
	[14]={2,{2,2}},			--GetPlayerPointInfo, Beweis des Mythos
	[15]={2,{3,3}},			--GetPlayerPointInfo Arkaniummarken
	[16]={0}, 	--unknown
	[17]={-1},				--Kräuter
	[18]={3,202916}, 		--GetCountInBagByName, Gildenrune
	[19]={3,202917}, 		--GetCountInBagByName, Gildenstein
	[20]={-1},				--Erz
	[21]={-1},				--Holz
	[22]={0},	--unknown
	[23]={0},	--unknown
	[24]={0},	--unknown
	[25]={0},	--unknown
	[26]={0},	--unknown
	}

StoreItemButton_OnClick = function(this, key)
	local function ReturnMaxNumToBuy(mt,price,mt2,price2)
		local num=-1;
		if moneyTypes[mt] and price~=0 then
			if moneyTypes[mt][1]==0 then
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Unknown MoneyType: "..mt.." price:"..price)
				num2=999;
			elseif moneyTypes[mt][1]==-1 then
				num=999;
				SendWarningMsg("not defined moneytype")--Keine Möglichkeit zur Abfrage
			elseif moneyTypes[mt][1]==1 then
				num=math.floor(GetPlayerMoney(moneyTypes[mt][2])/price) or 0;
			elseif moneyTypes[mt][1]==2 then
				num=math.floor(GetPlayerPointInfo(moneyTypes[mt][2][1],moneyTypes[mt][2][2],"")/price) or 0;
			elseif moneyTypes[mt][1]==3 then
				num=math.floor(GetCountInBagByName(TEXT("Sys"..moneyTypes[mt][2].."_name"))/price) or 0;
			end
		end
		local num2=-1
		if moneyTypes[mt2] and price2~=0 then
			if moneyTypes[mt2][1]==0 then
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Unknown MoneyType2: "..mt2.." price2:"..price2)
				num2=999;
			elseif moneyTypes[mt2][1]==-1 then
				num2=999;
				SendWarningMsg("not defined moneytype")--Keine Möglichkeit zur Abfrage
			elseif moneyTypes[mt2][1]==1 then
				num2=math.floor(GetPlayerMoney(moneyTypes[mt2][2])/price2) or 0;
			elseif moneyTypes[mt2][1]==2 then
				num2=math.floor(GetPlayerPointInfo(moneyTypes[mt2][2][1],moneyTypes[mt2][2][2],"")/price2) or 0;
			elseif moneyTypes[mt2][1]==3 then
				num2=math.floor(GetCountInBagByName(TEXT("Sys"..moneyTypes[mt2][2].."_name"))/price2) or 0;
			end
		end
		if num ==-1 and num2==-1 then
			num=999;
		elseif num ==-1 then
			num=num2;
		elseif num2>=0 and num>num2 then
			num=num2
		end
		return num
	end
	local index = this:GetParent().index;
	if( ((key == "LBUTTON") or (key == "RBUTTON")) and IsShiftKeyDown() ) then
		local itemLink;
		if( STOREFRAME_CURRENT_TAB == "SELL" ) then
			itemLink = GetStoreSellItemLink(index);
			if ( ChatEdit_AddItemLink(itemLink) ) then
				return;
			end
			local icon, name, price, moneyType, count, stock, maxHeap, secondPrice, secondMoneyType = GetStoreSellItemInfo(index);
			local itemCount=ReturnMaxNumToBuy(moneyType+1,price,secondMoneyType+1,secondPrice)
			if (itemCount <= 0) then
				SendWarningMsg(CR_STR_BUYOUT_ALERT.." to buy "..name);
				return;
			end		
			this.index = index;
			this.AskNumberFrameCallBack = function( button , Number )
				if (Number > maxHeap) then
					me.vars.multibuy.item[1]=this.index
					me.vars.multibuy.item[2]=maxHeap
					me.vars.multibuy.num = Number			
				else
					StoreBuyItem( this.index , Number );
				end
			end			
			OpenAskNumberFrame( 1, itemCount, this, "BOTTOMLEFT", "TOPRIGHT" );
		elseif( STOREFRAME_CURRENT_TAB == "BUYBACK" ) then
			itemLink = GetStoreBuyBackItemLink(index);
			ChatEdit_AddItemLink( itemLink );
		end
		return;
	elseif( key == "LBUTTON" and IsCtrlKeyDown() ) then
		local itemLink;
		if( STOREFRAME_CURRENT_TAB == "SELL" ) then
			itemLink = GetStoreSellItemLink(index);
		elseif( STOREFRAME_CURRENT_TAB == "BUYBACK" ) then
			itemLink = GetStoreBuyBackItemLink(index);
		end
		ItemPreviewFrame_SetItemLink( ItemPreviewFrame, itemLink );
		return;
	end
	if (key == "LBUTTON") then
		if (STOREFRAME_CURRENT_TAB == "SELL") then
			PickupStoreSellItem(index);
		elseif (STOREFRAME_CURRENT_TAB == "BUYBACK") then
			StoreBuyBackItem(index);
		end
	elseif (key == "RBUTTON") then
		if (STOREFRAME_CURRENT_TAB == "SELL") then
			StoreBuyItem(index);
		elseif (STOREFRAME_CURRENT_TAB == "BUYBACK") then
			StoreBuyBackItem(index);
		end
	end
end
--[[ ] ]]
-----------------------------------------------------------------------
-----------------------------------------------------------------------
-------------------------------Frames----------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------

local orig_MagicBoxFrame_SwitchBox=MagicBoxFrame_SwitchBox
function MagicBoxFrame_SwitchBox(this)
	orig_MagicBoxFrame_SwitchBox(this)
	if(  MagicBoxFrame.sw==true )then
		ExtFusion_Show:Enable()
	else
		ExtFusion_Show:Disable()
		--ExtFusion_FS:Hide() nicht benutzt, da Frame automatisch umschaltet wenn Fusion bzw akcraft gestartet
	end
end

function me.func.SetFrameText()
--akCraft
	local SystemStrings={	"",me.lang.akcraft_fire,me.lang.akcraft_water,me.lang.akcraft_wind,me.lang.akcraft_earth,--"",Feuer,Wasser,Wind,Erde,
							"",me.lang.akcraft_dust,me.lang.akcraft_sand,me.lang.akcraft_stone,me.lang.akcraft_diamond} --"",Staub,Sand,Stein,Diamant
	for i=1,#SystemStrings do
		local button=_G[ExtFusion_FS:GetName().."_Button"..(20+i)]
		button:SetSize(50,23)
		button:SetText(SystemStrings[i])
	end
	ExtFusion_FS_StartStern:SetText(me.lang.akcraft_start)
--fusion
	ExtFusion_FS_Button1:SetText(me.lang.fusion_fi)
	for i=2,20 do
		_G["ExtFusion_FS_Button"..i]:SetText(string.gsub(me.lang.fusion_tn,"<VAR>",i))
		
	end
	ExtFusion_FS_Max:SetText(me.lang.fusion_max)
	ExtFusion_FS_Reset:SetText(me.lang.fusion_reset)
	ExtFusion_FS_Start:SetText(me.lang.fusion_start)
--frame:
	ExtFusion_Show:SetText(me.lang.button)
	ExtFusion_FS_ConfigButton:SetText(me.lang.config_button)	
	ExtFusion_FS_ItemsToBank:SetText(me.lang.ItemsToBank)
--Config:
	--Fusis
	ExtFusion_Config_Title:SetText(string.gsub(me.lang.config_name,"<VAR>", me.version))
	for i=1,3 do
		_G["ExtFusion_Config_normal_Fusi"..i.."_Label"]:SetText(TEXT("Sys"..FusionStones[i][1].."_name"))
		_G["ExtFusion_Config_normal_Fusi"..i]:SetChecked(ExtFusion_Settings.FusionStones[i])
	end
	ExtFusion_Config_normal_UseBank_Label:SetText(me.lang.config_usebank)
	ExtFusion_Config_normal_UseBank:SetChecked(ExtFusion_Settings.UseBank)
	--slider
	local minvalue,maxvalue=0,2
	for i=1,3 do
		_G["ExtFusion_Config_normal_SpeedSlider"..i]:SetValueStepMode("FLOAT");
		_G["ExtFusion_Config_normal_SpeedSlider"..i.."_speed"]:SetText(ExtFusion_Settings.speed[i])
		_G["ExtFusion_Config_normal_SpeedSlider"..i]:SetMinMaxValues(minvalue,maxvalue)
		_G["ExtFusion_Config_normal_SpeedSlider"..i.."_maxspeed"]:SetText(maxvalue)
		_G["ExtFusion_Config_normal_SpeedSlider"..i.."_minspeed"]:SetText(minvalue)
		_G["ExtFusion_Config_normal_SpeedSlider"..i]:SetValue(ExtFusion_Settings.speed[i])
	end
	ExtFusion_Config_normal_SpeedSlider3_overline:SetText(string.gsub(me.lang.config_speed,"<VAR>",me.lang.config_smb))
	ExtFusion_Config_normal_SpeedSlider2_overline:SetText(string.gsub(me.lang.config_speed,"<VAR>",me.lang.config_akcraft))
	ExtFusion_Config_normal_SpeedSlider1_overline:SetText(string.gsub(me.lang.config_speed,"<VAR>",me.lang.config_fusion))
--Filter
	ExtFusion_Config_normal_list_Button1_Text:SetText(me.lang.config_filter_new)
	ExtFusion_Config_normal_list_Button1_Text:SetColor(1.0,1.0,0.0)
	ExtFusion_Config_filter_RuleCheck_Label:SetText(me.lang.config_filter_use)
	ExtFusion_Config_filter_SaveButton:SetText(me.lang.config_filter_save)
	ExtFusion_Config_filter_SaveCloseButton:SetText(me.lang.config_filter_close_save)
	ExtFusion_Config_filter_CloseButton:SetText(me.lang.config_filter_close)
	
--advanced
	ExtFusion_Config_advanced_PrintButton1:SetText(me.lang.config_advanced_print_filter)
	ExtFusion_Config_advanced_PrintButton2:SetText(me.lang.config_advanced_print_filtered_items)
	ExtFusion_Config_advanced_PrintButton3:SetText(me.lang.config_advanced_print_filtered_items_bank)
	
	ExtFusion_Config_advanced_list_Button0List1:SetText(me.lang.config_advanced_list_header_slot)
	ExtFusion_Config_advanced_list_Button0List2:SetText(me.lang.config_advanced_list_header_table)
	ExtFusion_Config_advanced_list_Button0List3:SetText(me.lang.config_advanced_list_header_bag_bank)
	ExtFusion_Config_advanced_list_Button0List4:SetText(me.lang.config_advanced_list_header_value)
	
	ExtFusion_Config_advanced_Slider1_overline:SetText(me.lang.config_advanced_slider1_txt)
	ExtFusion_Config_advanced_Slider1:SetValueStepMode("INT");
	ExtFusion_Config_advanced_Slider1_speed:SetText(1)
	ExtFusion_Config_advanced_Slider1:SetMinMaxValues(1,200)
	ExtFusion_Config_advanced_Slider1:SetValue(1)
	ExtFusion_Config_advanced_Slider1_speed:SetText(1)
	ExtFusion_Config_advanced_Slider1_maxspeed:SetText(200)
	ExtFusion_Config_advanced_Slider1_minspeed:SetText(1)
	
	ExtFusion_Config_advanced_Slider2_overline:SetText(me.lang.config_advanced_slider2_txt)
	ExtFusion_Config_advanced_Slider2:SetValueStepMode("INT");
	ExtFusion_Config_advanced_Slider2_speed:SetText(1)
	ExtFusion_Config_advanced_Slider2:SetMinMaxValues(1,200)
	ExtFusion_Config_advanced_Slider2:SetValue(200)
	ExtFusion_Config_advanced_Slider2_speed:SetText(1)
	ExtFusion_Config_advanced_Slider2_maxspeed:SetText(200)
	ExtFusion_Config_advanced_Slider2_minspeed:SetText(1)
end
-----------------------------------------------------------------------
---------------------------Fusion/Sternbild----------------------------
-----------------------------------------------------------------------
--[[ [ ]]
function me.func.FS_OnShow()
	me.func.GetBagpack()
	me.func.GetBank()
	if ExtFusion_Settings.UseBank and TimeLet_GetLetTime("BankLet")>0 then
		ExtFusion_FS_ItemsToBank:Enable()
	else
		ExtFusion_FS_ItemsToBank:Disable()
	end
end

function me.func.FS_GButton_OnClick(this)
	local num=this:GetID()
	if num > 20 then
		if num <=25 then
			if num ~=21 then
				me.vars.stern.type=num-20-1
			end
			for i=1,5 do
				local button=_G[this:GetParent():GetName().."_Button"..(20+i)]
				button:UnlockPushed()
				button:UnlockHighlight()
			end
		else
			if num ~=26 then
				me.vars.stern.level=num-25-0
			end
			for i=1,5 do
				local button=_G[this:GetParent():GetName().."_Button"..(25+i)]
				button:UnlockPushed()
				button:UnlockHighlight()
			end
		end
		this:LockPushed()
		this:LockHighlight()
	else
		for i=1,20 do
			me.vars.Fusion.queue[i]=0
		end
		me.vars.Fusion.queue[num]=1;
		me.func.GetBank()
		me.vars.Fusion.active=true
		me.vars.Fusion.filter=me.func.GetUsedFilter()
		me.vars.Fusion.Button=true	
		ExtFusion_FS_bg1:Show()
		if MagicBoxFrame.sw==false then
			MagicBoxFrame_SwitchBox(MagicBoxFramePureButton)
		end
	end
end

function me.func.FS_GButton_OnEnter(this)
	GameTooltip:SetOwner(this,"ANCHOR_BOTTOM",0,0);
	GameTooltip:ClearAllAnchors();
	GameTooltip:SetAnchor("TOPLEFT","TOPRIGHT",this,-2,-2);
	local num=this:GetID()
	if num ==1 then
		GameTooltip:SetText(me.lang.fusion_fi_tt)
	elseif num <=20 then
		GameTooltip:SetText(string.gsub(string.gsub(me.lang.fusion_tn_tt,"<VAR1>",num-1),"<VAR2>",num))
	elseif num<=25 then
		if me.vars.stern.level  then
			local id=element[num-21][me.vars.stern.level]
			GameTooltip:ClearAllAnchors();
			GameTooltip:SetAnchor("CENTER", "CENTER", this:GetName(),2,0);
			-- Show the tooltip
			GameTooltip:Show();
			GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT", 0, 0);
			GameTooltip:SetHyperLink(("|Hitem:%x|h|h"):format(id));
		end
	else
		if  me.vars.stern.type then
			local id=element[me.vars.stern.type][num-25]
			GameTooltip:ClearAllAnchors();
			GameTooltip:SetAnchor("CENTER", "CENTER", this:GetName(),2,0);
			-- Show the tooltip
			GameTooltip:Show();
			GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT", 0, 0);
			GameTooltip:SetHyperLink(("|Hitem:%x|h|h"):format(id)) ;
		end
	end
end

function me.func.FS_GEditBox_OnMouseWheel(this,delta)
	if (delta>0) then 
		if this:GetNumber()>0 then
			this:SetNumber(this:GetNumber()-1);
		end
	elseif (delta<0) then 
		if this:GetNumber()<999 then
			this:SetNumber(this:GetNumber()+1);
		end
	end;
	me.func.QueueStartStop(false)
end

function me.func.StartStop(bool)
	if type(bool)=="boolean" then
		me.vars.stern.start=bool
	else	
		me.vars.stern.start=not me.vars.stern.start
	end
	if me.vars.stern.start then
		ExtFusion_FS_StartStern:SetText(me.lang.akcraft_stop)
		ExtFusion_FS_bg2:Show()
		if MagicBoxFrame.sw==false then
			MagicBoxFrame_SwitchBox(MagicBoxFramePureButton)
		end
	else
		me.vars.stern.WaitForFusion=false
		ExtFusion_FS_StartStern:SetText(me.lang.akcraft_start)
		ExtFusion_FS_bg2:Hide()
	end
end

function me.func.QueueStartStop(bool)
	me.vars.Fusion.WaitForFusion=false
	if type(bool)=="boolean" then
		me.vars.Fusion.active=bool
	else	
		me.vars.Fusion.active=not me.vars.Fusion.active
	end
	if me.vars.Fusion.active then
		for i=1,20 do
			me.vars.Fusion.queue[i]=tonumber(_G["ExtFusion_FS_EditBox".. i]:GetText())
			me.vars.Fusion.queue[i]=(me.vars.Fusion.queue[i] or 0)
		end
		ExtFusion_FS_Start:SetText(me.lang.fusion_stop)		
		ExtFusion_FS_bg1:Show()
		if MagicBoxFrame.sw==false then
			MagicBoxFrame_SwitchBox(MagicBoxFramePureButton)
		end
		me.vars.Fusion.filter=me.func.GetUsedFilter()
		me.func.GetBank()
	else
		ExtFusion_FS_Start:SetText(me.lang.fusion_start)
		ExtFusion_FS_bg1:Hide()
	end
end

function me.func.reset()
	for i=1,20 do
		_G["ExtFusion_FS_EditBox".. i]:SetText(0)
		me.vars.Fusion.queue[i]=0
		me.func.QueueStartStop(false)
	end
end

function me.func.max()
	for i=1,20 do
		_G["ExtFusion_FS_EditBox".. i]:SetText(999)
		me.vars.Fusion.queue[i]=0
		me.func.QueueStartStop(false)
	end
end
--[[ ] ]]
-----------------------------------------------------------------------
-------------------------------Config----------------------------------
-----------------------------------------------------------------------
--[[ [ ]]
--CheckButton
function me.func.Config_CheckButtonOnClick(this)
	local id=this:GetID()
	ExtFusion_Settings.FusionStones[id]=_G["ExtFusion_Config_normal_Fusi"..id]:IsChecked()
	me.vars.Fusion.active=false;
end

--Liste	

function me.func.Config_OnListShow()
	ExtFusion_Config_normal_ScrollBar:SetValue(1);
	me.func.SortFilterTbl()
end

function me.func.Config_ListRepaint()
	ExtFusion.func.Config_ListHighlight()
	
	local maxvalue = #ExtFusion_Settings.Filters-10+1+1
	if (maxvalue < 1) then maxvalue = 1; end;
	ExtFusion_Config_normal_ScrollBar:SetMinMaxValues(1,maxvalue);
	local value = ExtFusion_Config_normal_ScrollBar:GetValue();
	for i=2,10 do
		local index = value-2+i;
		if (index <= #ExtFusion_Settings.Filters) then
			_G["ExtFusion_Config_normal_list_Button"..i]:Show()
			if ExtFusion_Settings.Filters[index][1]==false then
				_G["ExtFusion_Config_normal_list_Button"..i.."_Text"]:SetColor(1.0,0.0,0.0)
			else
				_G["ExtFusion_Config_normal_list_Button"..i.."_Text"]:SetColor(0.0,1.0,0.0)
			end
			_G["ExtFusion_Config_normal_list_Button"..i.."_Text"]:SetText(ExtFusion_Settings.Filters[index][2] or "failure")
			if type(ExtFusion_Settings.Filters[index][3])~="table" then ExtFusion_Settings.Filters[index][3]={all=true,} end
			if (type(ExtFusion_Settings.Filters[index][3][UnitName("player")])=="nil" and ExtFusion_Settings.Filters[index][3]["all"]) or ExtFusion_Settings.Filters[index][3][UnitName("player")] then
				_G["ExtFusion_Config_normal_list_Button"..i.."_bg_red"]:Hide()
			else
				_G["ExtFusion_Config_normal_list_Button"..i.."_bg_red"]:Show()
			end
			
		else
			_G["ExtFusion_Config_normal_list_Button"..i]:Hide()
			_G["ExtFusion_Config_normal_list_Button"..i.."_Text"]:SetText("")
		end;
	end;
end

function me.func.Config_RowOnEnter(this,id)
	if id ~=1 then
		GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT", -5, 0);
		local index = ExtFusion_Config_normal_ScrollBar:GetValue()-2+id;
		if type(ExtFusion_Settings.Filters[index][3][UnitName("player")])=="nil" and ExtFusion_Settings.Filters[index][3]["all"] or ExtFusion_Settings.Filters[index][3][UnitName("player")]  then
			GameTooltip:SetText(string.gsub(ExtFusion.lang.config_tooltips_savedchars,"<VALUE>",ExtFusion.lang.config_tooltips_value_true), 1, 1, 1 );
		else
			GameTooltip:SetText(string.gsub(ExtFusion.lang.config_tooltips_savedchars,"<VALUE>",ExtFusion.lang.config_tooltips_value_false), 1, 1, 1 );
		end
		
		local tbl={}
		for a,b in pairs (ExtFusion_Settings.Filters[index][3]) do
			local txt=ExtFusion.lang.config_tooltips_savedchars_n
			txt=string.gsub(string.gsub(txt,"<NAME>",a),"<BVALUE>",tostring(b))
			if b==true then
				txt=string.gsub(txt,"<VALUE>",ExtFusion.lang.config_tooltips_value_true)
			else
				txt=string.gsub(txt,"<VALUE>",ExtFusion.lang.config_tooltips_value_false)		
			end
			table.insert(tbl,{a,txt})
		end
		local function fn(a,b)
			if a[1]=="all" then return true end
			if b[1]=="all" then return false end
			if a[1]==UnitName("player") then return true end
			if b[1]==UnitName("player") then return false end
			if string.lower(a[1])>string.lower(b[1]) then 
				return false 
			else 
				return true 
			end
		end
		table.sort(tbl,fn)
		for i=1,#tbl do
			GameTooltip:AddLine(tbl[i][2], 1, 1, 1 );
		end
	end
	
end
function me.func.Config_RowClicked(this,key)
	if key=="LBUTTON" then
		if this:GetID()==1 then
			me.func.Config_ShowFilterEdit()
		else	
			me.func.Config_ShowFilterEdit(ExtFusion_Config_normal_ScrollBar:GetValue()+this:GetID()-2);
		end
	elseif key=="RBUTTON" then
		if this:GetID()==1 then
			me.func.Config_ShowFilterEdit()	
		else
			me.func.Config_ListHighlight(this:GetID())
			ExtFusion_Dropdown1.value=(ExtFusion_Config_normal_ScrollBar:GetValue()+this:GetID()-2);
			UIDropDownMenu_Initialize(ExtFusion_Dropdown1,ExtFusion.func.DropdownMenue1);
			ToggleDropDownMenu(ExtFusion_Dropdown1, 1, nil, "cursor", 1 ,1 )
		end
	end
end

function me.func.Config_ListHighlight(id)
	if (type(id) == "number") then
		id=id-1;
		ExtFusion_Config_normal_list_Highlight:ClearAllAnchors();
		ExtFusion_Config_normal_list_Highlight:SetAnchor("TOPLEFT", "TOPLEFT", ExtFusion_Config_normal_list, 5, 6+id*20);
		ExtFusion_Config_normal_list_Highlight:SetAnchor("BOTTOMRIGHT", "TOPRIGHT", ExtFusion_Config_normal_list, -5, 25+id*20);
		ExtFusion_Config_normal_list_Highlight:Show();
	else 
		ExtFusion_Config_normal_list_Highlight:Hide();
	end;
end;

--Liste Scrollbar
function me.func.Config_OnValueChanged(this)
	if ExtFusion_Config_normal:IsVisible() then
		if ExtFusion_Dropdown1:IsVisible() then
			ExtFusion_Dropdown1:Hide()
			ExtFusion_Dropdown1.value=nil;
		end
		me.func.Config_ListRepaint()
	elseif ExtFusion_Config_advanced:IsVisible() then
		me.func.Config_Advanced_ListRepaint()
	end
end

--SpeedSlider
function me.func.Config_SpeedOnValueChanged(this)
	if me.vars.loaded then	--loadoverride
		local value=math.floor(this:GetValue()*1000+0.5)/1000
		_G[this:GetName().."_speed"]:SetText(tostring(value))
		ExtFusion_Settings.speed[this:GetID()]=value
	end
end

--Ändern/neu;
function me.func.Config_EditTooltip(this)
	GameTooltip:SetOwner(this:GetParent():GetParent(), "ANCHOR_TOP", 0, 0);
	GameTooltip:ClearAllAnchors();
	GameTooltip:SetAnchor("TOPLEFT", "TOPRIGHT", this:GetParent():GetParent():GetName(),2,0);
	GameTooltip:SetText(me.lang.config_filter_tooltip[1])
	GameTooltip:AddLine(me.lang.config_filter_tooltip[2])
	GameTooltip:AddSeparator();
	GameTooltip:AddLine(me.lang.config_filter_tooltip[5])
	GameTooltip:AddSeparator();
	
	GameTooltip2:SetOwner(GameTooltip, "ANCHOR_RIGHT", 0, 0)
	GameTooltip2:SetText("")
	GameTooltip2:AddLine(me.lang.config_filter_tooltip[3])
	GameTooltip2:AddSeparator();
	GameTooltip2:AddLine(me.lang.config_filter_tooltip[4])
	GameTooltip2:AddSeparator();
	GameTooltip2:AddLine(me.lang.config_filter_tooltip[5])
	GameTooltip2:Show()
	GameTooltip:Show();
end

function me.func.Config_ShowFilterEdit(id)
	if type(id)=="number" and id~=0 then
		ExtFusion_Config_filter:SetID(id)
		ExtFusion_Config_filter:Show()
		ExtFusion_Config_advanced:Hide()
		ExtFusion_Config_normal:Hide()
		ExtFusion_Config_filter_RuleCheck:SetChecked(ExtFusion_Settings.Filters[id][1])
		ExtFusion_Config_filter_RuleEdit:SetText(ExtFusion_Settings.Filters[id][2])
		ExtFusion_Config_filter_SaveButton:Enable()
		ExtFusion_Config_filter_RuleEdit:SetFocus()
		ExtFusion_Config_filter_RuleEdit:SetPlaceCaret(string.len(ExtFusion_Settings.Filters[id][2]))--Cursor setzen
		ExtFusion_Config_filter_AllChar:SetChecked(ExtFusion_Settings.Filters[id][3]["all"])
		if type(ExtFusion_Settings.Filters[id][3][UnitName("player")])=="nil" then
			ExtFusion_Config_filter_Char:SetChecked(ExtFusion_Settings.Filters[id][3]["all"])
		else
			ExtFusion_Config_filter_Char:SetChecked(ExtFusion_Settings.Filters[id][3][UnitName("player")])
		end
		if ExtFusion_Config_filter_Char:IsChecked() then
			ExtFusion_Config_filter_RuleEdit_bg_red:Hide()
		else
			ExtFusion_Config_filter_RuleEdit_bg_red:Show()
		end
	else
		ExtFusion_Config_filter_AllChar:SetChecked(true)
		ExtFusion_Config_filter_RuleEdit_bg_red:Hide()
		ExtFusion_Config_filter_Char:SetChecked(true)
		ExtFusion_Config_filter:SetID(0)
		ExtFusion_Config_filter_SaveButton:Disable()
		ExtFusion_Config_filter_RuleCheck:SetChecked(false)
		ExtFusion_Config_filter_RuleEdit:SetText("")
		ExtFusion_Config_filter_RuleEdit:SetFocus()
		ExtFusion_Config_filter_RuleEdit:SetPlaceCaret(0)--Cursor setzen
		ExtFusion_Config_filter:Show()
		ExtFusion_Config_normal:Hide()
		ExtFusion_Config_advanced:Hide()
	end
	if ExtFusion_Config_filter_RuleCheck:IsChecked() then
		ExtFusion_Config_filter_RuleEdit:SetColor(0,1,0)
		ExtFusion_Config_filter_RuleCheck_Label:SetColor(0,1,0)
	else
		ExtFusion_Config_filter_RuleEdit:SetColor(1,0,0)	
		ExtFusion_Config_filter_RuleCheck_Label:SetColor(1,0,0)
	end
end

function me.func.Config_ReadFilterEdit()
	if ExtFusion_Config_filter:GetID()==0 then
		local txt=ExtFusion_Config_filter_RuleEdit:GetText()
		while string.gsub(txt,"\n","")~=txt or string.gsub(txt,"  "," ")~=txt do
			txt=string.gsub(txt,"  "," ")
			txt=string.gsub(txt,"\n","")
		end
		if me.func.Config_CheckFilter(txt) then
			local tbl={
				[1]=ExtFusion_Config_filter_RuleCheck:IsChecked(),
				[2]=txt,
				[3]={
					all=ExtFusion_Config_filter_AllChar:IsChecked(),
					[UnitName("player")]=ExtFusion_Config_filter_Char:IsChecked(),
					}
				}
			table.insert(ExtFusion_Settings.Filters,tbl)
			return true
		else
			return false
		end
	else
		local txt=ExtFusion_Config_filter_RuleEdit:GetText()
		while string.gsub(txt,"\n","")~=txt or string.gsub(txt,"  "," ")~=txt do
			txt=string.gsub(txt,"  "," ")
			txt=string.gsub(txt,"\n","")
		end
		if me.func.Config_CheckFilter(txt) then
			ExtFusion_Settings.Filters[ExtFusion_Config_filter:GetID()][1]=ExtFusion_Config_filter_RuleCheck:IsChecked()
			ExtFusion_Settings.Filters[ExtFusion_Config_filter:GetID()][2]=txt
			ExtFusion_Settings.Filters[ExtFusion_Config_filter:GetID()][3]["all"]=ExtFusion_Config_filter_AllChar:IsChecked()
			ExtFusion_Settings.Filters[ExtFusion_Config_filter:GetID()][3][UnitName("player")]=ExtFusion_Config_filter_Char:IsChecked()
			return true
		else
			return false
		end
	end
end

function me.func.Config_CheckFilter(txt)
	local txt=string.lower(txt)
	while string.gsub(txt," ","")~=txt do
		txt=string.gsub(txt," ","")
	end
	local filter,num={},1
	while string.find(txt,logicand) do
		filter[num]=string.sub(txt,0,string.find(txt,logicand)-1)
		txt=string.sub(txt,string.find(txt,logicand)+1,string.len(txt))
		num=num+1
		if num > 20 then break end
	end
	filter[num]=txt;
	local bool=true
	for i=1,#filter do
		local check=false
		if string.match(filter[i],"^"..booleannot..".+") then
			filter[i]=string.sub(filter[i],2,string.len(filter[i]))
		end
		for y=1,#Filterpatterns1 do
			for z=1,#Filterpatterns1[y] do
				if string.match(filter[i],"^"..Filterpatterns1[y][z]..".*") then
					check=true
				end
			end
		end
		if not check then
			SendWarningMsg(filter[i].." --> Fehler im Filter!")
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..filter[i].." --> Fehler im Filter!")
			bool=false
		end
	end
	return bool
end

function me.func.SortFilterTbl()
	a,b,c,d,e,ret={},{},{},{},{},{}
	for i=1,#ExtFusion_Settings.Filters do
		if ExtFusion_Settings.Filters[i][1]==true then
			table.insert(a,ExtFusion_Settings.Filters[i])
		else
			table.insert(b,ExtFusion_Settings.Filters[i])
		end
	end

	for i=1,#a do
		if string.find(a[i][2],"mana") then
			if string.find(a[i][2],"|mana") then
				table.insert(d,a[i])	--Regeln die true sind und nur auf Items angewendet werden
			else
				table.insert(e,a[i])	--Regeln die true sind und nur auf Manasteine angewendet werden		
			end
		else
			table.insert(c,a[i])	--Restliche Regeln, die true sind
		end
	end
	for i=1,#c do
		table.insert(ret,c[i])
	end
	for i=1,#d do
		table.insert(ret,d[i])
	end
	for i=1,#e do
		table.insert(ret,e[i])
	end
	
	c,d,e={},{},{},{},{}
	for i=1,#b do
		if string.find(b[i][2],"mana") then
			if string.find(b[i][2],"|mana") then
				table.insert(d,b[i])	--Regeln die false sind und nur auf Items angewendet werden
			else
				table.insert(e,b[i])	--Regeln die false sind und nur auf Manasteine angewendet werden		
			end
		else
			table.insert(c,b[i])	--Restliche Regeln, die false sind
		end
	end
	for i=1,#c do
		table.insert(ret,c[i])
	end
	for i=1,#d do
		table.insert(ret,d[i])
	end
	for i=1,#e do
		table.insert(ret,e[i])
	end
	ExtFusion_Settings.Filters=ret
end
--[[ ] ]]

--advanced
--[[ [ ]]
function me.func.Config_advanced_SliderOnValueChanged(this)
	local value=this:GetValue()
	if this==ExtFusion_Config_advanced_Slider1 then
		if ExtFusion_Config_advanced_Slider1:GetValue() > ExtFusion_Config_advanced_Slider2:GetValue() then
			ExtFusion_Config_advanced_Slider2:SetValue(value)
		end
	else
		if ExtFusion_Config_advanced_Slider1:GetValue() > ExtFusion_Config_advanced_Slider2:GetValue() then
			ExtFusion_Config_advanced_Slider1:SetValue(value)
		end
	end
	_G[this:GetName().."_speed"]:SetText(tostring(value))
end
--Liste	
local sorttype={1,true}
local actualtbl={}
function me.func.Config_advanced_OnListShow()
	actualtbl={}
	sorttype={1,true}
	ExtFusion_Config_advanced_ScrollBar:SetMinMaxValues(1,1);
	me.func.Config_Advanced_ListRepaint()
end

function me.func.Config_Advanced_ListRepaint(tbl)
	if tbl then
		actualtbl=tbl
	end
	if #actualtbl>0 then
		local maxvalue = #actualtbl-10+1
		if (maxvalue < 1) then maxvalue = 1; end;
		ExtFusion_Config_advanced_ScrollBar:SetMinMaxValues(1,maxvalue);
		local value = ExtFusion_Config_advanced_ScrollBar:GetValue();
		for i=1,10 do
			local index = value-1+i;
			if (index <= #actualtbl) then
				_G["ExtFusion_Config_advanced_list_Button"..i]:Show()
				if actualtbl[index][4] then
					for z=1,4 do
						_G["ExtFusion_Config_advanced_list_Button"..i.."List"..z.."_Text"]:SetColor(0,1,0)
					end
				else
					for z=1,4 do
						_G["ExtFusion_Config_advanced_list_Button"..i.."List"..z.."_Text"]:SetColor(1,0,0)
					end				
				end
				_G["ExtFusion_Config_advanced_list_Button"..i.."List1_Text"]:SetText(actualtbl[index][1])
				if actualtbl[index][5] then
					_G["ExtFusion_Config_advanced_list_Button"..i.."List2_Text"]:SetText(actualtbl[index][2][1])
				else	
					_G["ExtFusion_Config_advanced_list_Button"..i.."List2_Text"]:SetText(actualtbl[index][2])
				end
				_G["ExtFusion_Config_advanced_list_Button"..i.."List3_Text"]:SetText(actualtbl[index][3])
				_G["ExtFusion_Config_advanced_list_Button"..i.."List4_Text"]:SetText(tostring(actualtbl[index][4]))
			else
				for z=1,4 do
					_G["ExtFusion_Config_advanced_list_Button"..i.."List"..z.."_Text"]:SetText()
				end	
				_G["ExtFusion_Config_advanced_list_Button"..i]:Hide()
			end;
		end;
	else
		for i=1,10 do
			_G["ExtFusion_Config_advanced_list_Button"..i]:Hide()
		end
	end
end

function me.func.Config_Advanced_ListTooltip(this,row,column)
	GameTooltip:SetOwner(this,"ANCHOR_BOTTOM",0,0);
	GameTooltip:ClearAllAnchors();
	GameTooltip:SetAnchor("TOPLEFT","BOTTOMRIGHT",this,-2,-2);
	local value = ExtFusion_Config_advanced_ScrollBar:GetValue();
	local index = value-1+row;
	if column==2 then
		if actualtbl[index][5] then
			if actualtbl[index][2][2].item then
				GameTooltip:SetHyperLink("|Hitem:"..me.func.makeitemlink(actualtbl[index][2][2]).."|h|h")
			else
				GameTooltip:SetHyperLink("|Hitem:"..me.func.makeitemlink2(actualtbl[index][2][2]).."|h|h")
			end
		else
			
			if me.lang.config_advanced_tooltips_number[tostring(actualtbl[index][2])] then
				GameTooltip:SetText(actualtbl[index][2])
				GameTooltip:AddLine(me.lang.config_advanced_tooltips_number[tostring(actualtbl[index][2])])
			elseif tonumber(actualtbl[index][2])>1000 then 
				GameTooltip:SetText(actualtbl[index][2])
				GameTooltip:AddLine(me.lang.config_advanced_tooltips_number["1xxx_4xxx"])
			else
				GameTooltip:SetText(me.lang.config_advanced_tooltips_unknown)
			end
		end
		GameTooltip:Show()
	elseif column==3 then
		if string.match((actualtbl[index][3] or ""),"|Hitem:%x+ %x+ %x+ %x+ %x+ %x+ %x+ %x+ %x+ %x+ %x+ %x+|h.+|h") then
			GameTooltip:SetHyperLink(actualtbl[index][3])
			GameTooltip:Show()
		end
	elseif column==4 then
		if actualtbl[index][6] then
			if actualtbl[index][4] then
				GameTooltip:SetText("|cff00ff00"..actualtbl[index][6])
			else
				GameTooltip:SetText("|cffff0000"..actualtbl[index][6])			
			end
		end
	end
	
	GameTooltip1:Hide()
	GameTooltip2:Hide()
end

function me.func.makeitemlink(tbl)
	local link="<itemid> <bind> <multistuff> <statAB> <statCD> <statEF> <rune1> <rune2> <rune3> <rune4> <dura> "
	link=string.gsub(link,"<bind>",tbl.bound)
	link=string.gsub(link,"<itemid>",string.format("%x",tbl.id))
	link=string.gsub(link,"<dura>",string.format("%x",(tbl.dura[1] or 0)*100))
	
	local stat1=string.sub(string.format("%x",(tbl.stats[1] or 0)),2)
	local stat2=string.sub(string.format("%x",(tbl.stats[2] or 0)),2)
	local stat3=string.sub(string.format("%x",(tbl.stats[3] or 0)),2)
	local stat4=string.sub(string.format("%x",(tbl.stats[4] or 0)),2)
	local stat5=string.sub(string.format("%x",(tbl.stats[5] or 0)),2)
	local stat6=string.sub(string.format("%x",(tbl.stats[6] or 0)),2)
	local stat12=stat1..stat2
	local stat34=stat3..stat4
	local stat56=stat5..stat6
	if string.len(stat12)==0 then stat12=0 end
	if string.len(stat34)==0 then stat34=0 end
	if string.len(stat56)==0 then stat56=0 end
	link=string.gsub(link,"<statAB>",stat12)
	link=string.gsub(link,"<statCD>",stat34)
	link=string.gsub(link,"<statEF>",stat56)
	
	local rune1=string.format("%x",(tbl.runes[1] or 0))
	local rune2=string.format("%x",(tbl.runes[2] or 0))
	local rune3=string.format("%x",(tbl.runes[3] or 0))
	local rune4=string.format("%x",(tbl.runes[4] or 0))
	if string.len(rune1)==0 then rune1=0 end
	if string.len(rune2)==0 then rune2=0 end
	if string.len(rune3)==0 then rune3=0 end
	if string.len(rune4)==0 then rune4=0 end
	link=string.gsub(link,"<rune1>",rune1)
	link=string.gsub(link,"<rune2>",rune2)
	link=string.gsub(link,"<rune3>",rune3)
	link=string.gsub(link,"<rune4>",rune4)
	local tier=string.format("%02x",(tbl.tiered or 0)+(tbl.rarity*32 or 0)+10)
	local plus=string.format("%02x",(tbl.plus or 0)+(tbl.runeslots or 0)*32)
	local maxdura=string.format("%02x",(tbl.dura[2] or 0))
	local multistuff="00"..plus..tier..maxdura
	link=string.gsub(link,"<multistuff>",multistuff)
	local hash=(string.format("%x",CalculateItemLinkHash(link)))
	link=link..hash
	return link
end

function me.func.makeitemlink2(tbl)
	local link="<itemid> 1 0 <statAB> <statCD> <statEF> 0 0 0 0 0 "
	link=string.gsub(link,"<itemid>",string.format("%x",tbl.id))

	local stat1=string.format("%x",string.sub((tbl.stats[1] or 0),2))
	local stat2=string.format("%x",string.sub((tbl.stats[2] or 0),2))
	local stat3=string.format("%x",string.sub((tbl.stats[3] or 0),2))
	local stat4=string.format("%x",string.sub((tbl.stats[4] or 0),2))
	local stat5=string.format("%x",string.sub((tbl.stats[5] or 0),2))
	local stat6=string.format("%x",string.sub((tbl.stats[6] or 0),2))
	local stat12=stat1..stat2
	local stat34=stat3..stat4
	local stat56=stat5..stat6
	if string.len(stat12)==0 then stat12=0 end
	if string.len(stat34)==0 then stat34=0 end
	if string.len(stat56)==0 then stat56=0 end
	link=string.gsub(link,"<statAB>",stat12)
	link=string.gsub(link,"<statCD>",stat34)
	link=string.gsub(link,"<statEF>",stat56)
	local hash=(string.format("%x",CalculateItemLinkHash(link)))
	link=link..hash
	return link
end
--table sortieren
--[[ [ ]]
function me.func.Config_Advanced_sorttable(index)
	if type(ExtFusion.func["Config_Advanced_sorttable"..index])=="function" then
		if sorttype[1]==index then 
			sorttype[2]=not sorttype[2]
		else
			sorttype[1]=index
			sorttype[2]=true
		end
		check=true
		for i=1,#actualtbl do
			if actualtbl[i][5]==false then
				check=false
				break
			end
		end
		--if (index~=2 and index~=3)  or check then
			ExtFusion.func["Config_Advanced_sorttable"..index]()
			me.func.Config_Advanced_ListRepaint()
		--else
		--	SendWarningMsg("Nicht möglich!")
		--end
	end
end
function me.func.Config_Advanced_sorttable1()
	local fn=function (a,b)
		check=true
		if a[1]>b[1] then
			check=true
		else
			check=false
		end
		if sorttype[2] then
			return (not check)
		else
			return check
		end
	end
	table.sort(actualtbl,fn )
end
function me.func.Config_Advanced_sorttable2()
	local tbl1,tbl2,tbl3={},{},{}
	for i=1,#actualtbl do
		if type(actualtbl[i][2])=="table" then
			table.insert(tbl1,actualtbl[i])
		elseif type(actualtbl[i][2])=="number" then
			table.insert(tbl2,actualtbl[i])
		else
			table.insert(tbl3,actualtbl[i])
			DEFAULT_CHAT_FRAME:AddMessage("Error sort2(3): "..tostring(actualtbl[i]))
		end
	end
	tbl1=me.func.Config_Advanced_sorttable2_name(tbl1)
	local fn=function(tbl)
		for i=1,#tbl-1 do
			if tbl[i+1][2]>tbl[i][2] then
				local a=tbl[i]
				tbl[i]=tbl[i+1]
				tbl[i+1]=a	
				i=1
			end
		end
		ret={}
		if sorttype[2] then
			ret=tbl
		else
			for i=1,#tbl do
				table.insert(ret,tbl[#tbl-i+1])
			end
		end	
		return ret
	end
	tbl2=me.func.Config_Advanced_sorttable2_number(tbl2)
	actualtbl={}
	if sorttype[2] then
		for i=1,#tbl1 do
			table.insert(actualtbl,tbl1[i])
		end
		for i=1,#tbl2 do
			table.insert(actualtbl,tbl2[i])
		end
		for i=1,#tbl3 do
			table.insert(actualtbl,tbl3[i])
		end
	else
		for i=1,#tbl2 do
			table.insert(actualtbl,tbl2[i])
		end
		for i=1,#tbl1 do
			table.insert(actualtbl,tbl1[i])
		end
		for i=1,#tbl3 do
			table.insert(actualtbl,tbl3[i])
		end
	end
end
function me.func.Config_Advanced_sorttable2_number(tbl)
	for i=1, #tbl-1 do
		if tbl[i][2]<tbl[i+1][2] then
			local a=tbl[i]
			tbl[i]=tbl[i+1]
			tbl[i+1]=a
			return me.func.Config_Advanced_sorttable2_number(tbl)
		end		
	end
	ret={}
	if sorttype[2] then
		ret=tbl
	else
		for i=1,#tbl do
			table.insert(ret,tbl[#tbl-i+1])
		end
	end	
	return ret
end
function me.func.Config_Advanced_sorttable2_name(tbl)
	for i=1, #tbl-1 do
		local txt1=string.gsub(string.gsub(string.gsub(string.gsub(string.lower(tbl[i][2][1] or ""),"ü","uz"),"ä","az"),"ö","oz"),"ß","ss")
		local txt2=string.gsub(string.gsub(string.gsub(string.gsub(string.lower(tbl[i+1][2][1] or ""),"ü","uz"),"ä","az"),"ö","oz"),"ß","ss")
		txt1=string.gsub(txt1,"[^%l^%d]","")
		txt2=string.gsub(txt2,"[^%l^%d]","")
		
		local l1,l2=string.len(txt1),string.len(txt2)
		local length=l1
		if l1>l2 then
			length=l2
		end
		local z=1
		while string.byte(txt1,z)==string.byte(txt2,z) and z<length do
			z=z+1
		end
		if string.byte(txt1,z)<string.byte(txt2,z) then
			local a=tbl[i]
			tbl[i]=tbl[i+1]
			tbl[i+1]=a
			return me.func.Config_Advanced_sorttable2_name(tbl)
		end		
	end
	ret={}
	if not sorttype[2] then
		ret=tbl
	else
		for i=1,#tbl do
			table.insert(ret,tbl[#tbl-i+1])
		end
	end	
	return ret
end
function me.func.Config_Advanced_sorttable3()
	local tbl1,tbl2={},{}
	for i=1,#actualtbl do
		if actualtbl[i][3]=="" then
			table.insert(tbl1,actualtbl[i])
		else
			table.insert(tbl2,actualtbl[i])		
		end
	end
	actualtbl={}
	if sorttype[2] then
		tbl2=me.func.Config_Advanced_sorttable3_name1(tbl2)
		for i=1,#tbl1 do
			table.insert(actualtbl,tbl1[i])
		end
		for i=1,#tbl2 do
			table.insert(actualtbl,tbl2[i])
		end
	else
		tbl2=me.func.Config_Advanced_sorttable3_name2(tbl2)
		for i=1,#tbl2 do
			table.insert(actualtbl,tbl2[i])
		end
		for i=1,#tbl1 do
			table.insert(actualtbl,tbl1[i])
		end
	end
end
function me.func.Config_Advanced_sorttable3_name1(tbl)
	for i=1, #tbl-1 do
		local _,_,txt1=ParseHyperlink(tbl[i][3] or "")
		local _,_,txt2=ParseHyperlink(tbl[i+1][3] or "")
		txt1=string.gsub(string.gsub(string.gsub(string.gsub(string.lower(txt1 or ""),"ü","uz"),"ä","az"),"ö","oz"),"ß","ss")
		txt2=string.gsub(string.gsub(string.gsub(string.gsub(string.lower(txt2 or ""),"ü","uz"),"ä","az"),"ö","oz"),"ß","ss")
		txt1=string.gsub(txt1,"[^%l^%d]","")
		txt2=string.gsub(txt2,"[^%l^%d]","")
		
		local l1,l2=string.len(txt1),string.len(txt2)
		local length=l1
		if l1>l2 then
			length=l2
		end
		local z=1
		while string.byte(txt1,z)==string.byte(txt2,z) and z<length do
			z=z+1
		end
		if (string.byte(txt1,z) or 0)>(string.byte(txt2,z)or 0) then
			local a=tbl[i]
			tbl[i]=tbl[i+1]
			tbl[i+1]=a
			return me.func.Config_Advanced_sorttable3_name1(tbl)
		end
	end
	ret={}
	if not sorttype[2] then
		ret=tbl
	else
		for i=1,#tbl do
			table.insert(ret,tbl[#tbl-i+1])
		end
	end	
	return ret
end
function me.func.Config_Advanced_sorttable3_name2(tbl)
	for i=1, #tbl-1 do
		local _,_,txt1=ParseHyperlink(tbl[i][3] or "")
		local _,_,txt2=ParseHyperlink(tbl[i+1][3] or "")
		txt1=string.gsub(string.gsub(string.gsub(string.gsub(string.lower(txt1 or ""),"ü","uz"),"ä","az"),"ö","oz"),"ß","ss")
		txt2=string.gsub(string.gsub(string.gsub(string.gsub(string.lower(txt2 or ""),"ü","uz"),"ä","az"),"ö","oz"),"ß","ss")
		txt1=string.gsub(txt1,"[^%l^%d]","")
		txt2=string.gsub(txt2,"[^%l^%d]","")
		
		local l1,l2=string.len(txt1),string.len(txt2)
		local length=l1
		if l1>l2 then
			length=l2
		end
		local z=1
		while string.byte(txt1,z)==string.byte(txt2,z) and z<length do
			z=z+1
		end
		if (string.byte(txt1,z) or 0)<(string.byte(txt2,z)or 0) then
			local a=tbl[i]
			tbl[i]=tbl[i+1]
			tbl[i+1]=a
			return me.func.Config_Advanced_sorttable3_name2(tbl)
		end
	end
	ret={}
	if sorttype[2] then
		ret=tbl
	else
		for i=1,#tbl do
			table.insert(ret,tbl[#tbl-i+1])
		end
	end	
	return ret
end
function me.func.Config_Advanced_sorttable4()
	local sort1,sort2={},{}
	for i=1,#actualtbl do
		if actualtbl[i][4] then
			table.insert(sort1,actualtbl[i])
		else
			table.insert(sort2,actualtbl[i])
		end
	end
	actualtbl={}
	if sorttype[2] then
		for i=1,#sort1 do
			table.insert(actualtbl,sort1[i])
		end
		for i=1,#sort2 do
			table.insert(actualtbl,sort2[i])
		end
	else
		for i=1,#sort2 do
			table.insert(actualtbl,sort2[i])
		end
		for i=1,#sort1 do
			table.insert(actualtbl,sort1[i])
		end
	end
end
--[[ ] ]]
--[[ ] ]]
-----------------------------------------------------------------------
-------------------------------Helper----------------------------------
-----------------------------------------------------------------------
--[[ [ ]]
function me.func.LoadLoka()
	local language = string.lower(GetLanguage())
	local func, error = loadfile("Interface/AddOns/ExtendedFusion/lang/"..language..".lua")
	if error then
		func, error = loadfile("Interface/AddOns/ExtendedFusion/lang/de.lua")
		if error then
			DEFAULT_CHAT_FRAME:AddMessage("Loka konnte nicht geladen werden!")
		else
			me.lang=func()
		end
	else
		me.lang=func()
	end
end

--//////////////////////////////////////////////////////////////////
--[[ [ ]]
-- Runes of Magic item link hash calculation code

-- Author: Valacar (aka Duppy of the Runes of Magic US Osha server)
-- Release Date: September 12th, 2010

-- Credit goes to Neil Richardson for the xor, lshift, and rshift function
-- which I slightly modified. The original code can be found at:
-- http://luamemcached.googlecode.com/svn/trunk/CRC32.lua

-- I could care less what anyone does with the code (i.e. it's public domain),
-- but I'd very much appreciate being given credit (to me Valacar) if you do
-- use the code in any way.


-- Exclusive OR
local function xor(a, b)
    local calc = 0
    for i = 32, 0, -1 do
        local val = 2 ^ i
        local aa = false
        local bb = false
        if a == 0 then
            calc = calc + b
            break
        end
        if b == 0 then
            calc = calc + a
            break
        end
        if a >= val then
            aa = true
            a = a - val
        end
        if b >= val then
            bb = true
            b = b - val
        end
        if not (aa and bb) and (aa or bb) then
             calc = calc + val
        end
    end
     return calc
end

-- binary shift left
local function lshift(num, left)
     local res = num * (2 ^ left)
     return res % (2 ^ 32)
end

-- binary shift right
local function rshift(num, right)
    right = right % 0x20
    local res = num / (2 ^ right)
    return math.floor(res)
end

-- get lower word of a 32-bit number
local function loword(num)
    return rshift(lshift(num, 16), 16)
end

-- get high word of a 32-bit number
local function hiword(num)
    return rshift(num, 16) % 2^16
end

-- multiply two 32-bit numbers, but returns only the low dword of the 64-bit result
local function mymul(num1, num2)
    local x = loword(num2) * num1
    local y = (hiword(num2) * num1) * 2^16
    local a = hiword(x) + hiword(y)
    local b = loword(x)

    return (a * 2^16) + b
end

--//////////////////////////////////////////////////////////////////

-- Calculates hash value of an item based on first 11 hex numbers of an item link
function CalculateItemLinkHash(values)
    assert(type(values) == "string", "Must pass a string to CalculateItemLinkHash consisting of 11 hex values separated by a space.")

    local num = { values:match("^(%x+)%s+(%x+)%s+(%x+)%s+(%x+)%s+(%x+)%s+(%x+)%s+(%x+)%s+(%x+)%s+(%x+)%s+(%x+)%s+(%x+)") }
    assert(#num == 11, "11 hex values required!")

    local sum = 0
    for s = 1, 11 do
        num[s] = tonumber(num[s], 16)
        sum = sum + num[s]
    end

    local a,b,c,d,e,x,i = sum,0,0,0,0,0,0

    repeat
        d = num[x+1]
        b = d
        b = b * x
        b = b % 2^32
        e = d
        e = rshift(e, i)
        i = i + 0x10
        x = x + 1
        e = e + a
        e = e % 2^32
        b = b + e
        b = b % 2^32
        b = xor(b, d)
        a = b
    until (i >= 0xB0)

    local j = 0

    repeat
        d = num[j+1]
        c = d + 1
        c = mymul(c, a)
        c = c % 2^32
        a = d
        a = mymul(a, c)
        a = a % 2^32
        a = rshift(a, 16)
        a = a + c
        j = j + 1
        a = xor(a, d)
    until (j >= 0x0B)

    hash = loword(a)

    return hash
end
--[[ ] ]]
--[[ ] ]]
-----------------------------------------------------------------------
------------------------------Dropdown---------------------------------
-----------------------------------------------------------------------
--[[ [ ]]
function me.func.initialize()
	UIDropDownMenu_Initialize(ExtFusion_Dropdown1,ExtFusion.func.DropdownMenue1);
end

function me.func.DropdownMenue1()
	local menuitem = {};
		menuitem.notCheckable = 1;
		menuitem.text = me.lang.config_filter_dropdown_options
		menuitem.isTitle=1
		UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
		
		local menuitem = {};
		menuitem.func = function() 
			me.func.Config_ShowFilterEdit(ExtFusion_Dropdown1.value)
		end;
		menuitem.text = me.lang.config_filter_dropdown_change
		UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
		
		menuitem.func = function() 
			table.remove(ExtFusion_Settings.Filters,ExtFusion_Dropdown1.value)
			ExtFusion.func.Config_ListRepaint()
		end;
		menuitem.text = me.lang.config_filter_dropdown_delete
		UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
	
end
--[[ ] ]]
_G[me.name] = me;

